diff -uwrN sourceold/scripts/dp88_ar.cpp source/scripts/dp88_ar.cpp
--- sourceold/scripts/dp88_ar.cpp	2012-05-23 10:32:15.882812500 +0800
+++ source/scripts/dp88_ar.cpp	2012-08-22 21:20:45.922851500 +0800
@@ -1007,6 +1007,8 @@
 	delay is required to prevent the normal harvester AI taking over */
 	if ( useAI )
 		Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 1, (float)Get_Int_Parameter("aiStartDelay") );
+	if (strlen(Get_Parameter("idleAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
 }
 
 
@@ -1075,7 +1077,8 @@
       // Stop the mining animation
       animating = false;
       obj->As_PhysicalGameObj()->Clear_Animation();
-
+      if (strlen(Get_Parameter("idleAnimation")) > 0)
+         Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
       // If using the AI start driving to the refinery
       if ( useAI )
       {
@@ -1187,6 +1190,8 @@
   // Stop the mining animation
   animating = false;
   obj->As_PhysicalGameObj()->Clear_Animation();
+  if (strlen(Get_Parameter("idleAnimation")) > 0)
+    Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
 
   // If this is an AI miner and our state is still collecting ore then we were probably shoved out
   // of the ore field by some bully in a vehicle so drive back in to finish mining
@@ -1280,6 +1285,9 @@
 		aiState = MINER_AISTATE_DRIVE_TO_ORE;
 		DriveToOreField(obj);
 	}
+	obj->As_PhysicalGameObj()->Clear_Animation();
+	if (strlen(Get_Parameter("idleAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
 }
 
 
@@ -2715,21 +2723,18 @@
 
 void dp88_AR_Prism_Tower::Created( GameObject *obj )
 {
-	Init(obj);
-	loadSettings(obj, false, false);
+  dp88_AI_ChargedTurret::Created(obj);
 
 	// Initialise member variables
-	isChargingTower = false;
+  isAssistingTower = false;
 	adjacentTowerCount = 0;
 	adjacentTowers = NULL;
 	
 	// Register the tower
 	registerTower(Commands->Get_ID(obj),this);
-
-	// Start think timer to manage the charge level
-	Commands->Start_Timer ( obj, this, 1.0, TIMER_PRISMTOWER_THINK );
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::Damaged ( GameObject *obj, GameObject *damager, float amount )
 {
@@ -2742,6 +2747,7 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::Killed ( GameObject *obj, GameObject *killer )
 {
@@ -2758,6 +2764,7 @@
 	deregisterTower(Commands->Get_ID(obj));
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::Destroyed ( GameObject *obj )
 {
@@ -2765,13 +2772,14 @@
 	deregisterTower(Commands->Get_ID(obj));
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::Custom ( GameObject *obj, int type, int param, GameObject *sender )
 {
 	// If we recieve a stop charging message from the tower we are currently
 	// charging then we should stop all actions
-	if ( type == CUSTOM_PRISMTOWER_STOP_CHARGING && isChargingTower && Commands->Get_ID(sender) == targetID )
-		StopCharging(obj);
+  if ( type == CUSTOM_PRISMTOWER_STOP_CHARGING && isAssistingTower && Commands->Get_ID(sender) == targetID )
+    StopAssisting(obj);
 
 
 	// If we recieve a request charging message from another tower then we
@@ -2779,15 +2787,13 @@
 	// current target (if any) and, if so, start charging them
 	else if ( type == CUSTOM_PRISMTOWER_REQUEST_CHARGING )
 	{
-		// Are we idle? If so then there's no reason not to simply start
-		// charging immediatly
+    // Are we idle? If so then there's no reason not to simply start charging immediatly
 		if ( targetID == 0 )
-			StartCharging(obj, sender, (float)param);
+      StartAssisting(obj, sender, (float)param);
 
-		// Is this request from the tower we are currently charging? If so
-		// then update the last seen time and priority and send out the
-		// assistance request to any other adjacent towers
-		else if ( isChargingTower && targetID == Commands->Get_ID(sender) )
+    // Is this request from the tower we are currently charging? If so then update the last seen
+    // time and priority and forward the assistance request to any other adjacent towers
+    else if ( isAssistingTower && targetID == Commands->Get_ID(sender) )
 		{
 			targetLastSeen = (int)time(NULL);
 			targetPriority = (float)param;
@@ -2795,22 +2801,26 @@
 			return;
 		}
 
-		// Is the priority of the request greater than the priority of our
-		// current target (either another tower or an enemy)? If so then
-		// stop what we are doing and charge the requester
+    // Is the priority of the request greater than the priority of our current target (either
+    // another tower or an enemy)? If so then stop what we are doing and charge the requester
 		else if ( param > targetPriority )
-			StartCharging(obj, sender, (float)param );
+      StartAssisting(obj, sender, (float)param );
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::Timer_Expired ( GameObject *obj, int number )
 {
-	/* Prism tower logic timer - handles charge level etc */
-	if ( number == TIMER_PRISMTOWER_THINK )
+  // Piggy back our assistance polling and charge refilling on the existing think timer
+  if ( number == TIMER_CUSTOMAI_THINK )
 	{
-		/* Send out assistance requests, otherwise the tower will 'time out'
-		on the last seen check */
+    /* Send out assistance requests to ensure other towers don't time out on the 'last seen' check
+    *
+    * \todo
+    *   Can this screw up the timings between charging towers and the attacking tower? Need to think
+    *   this through sometime and possibly do some experimentation...
+    */
 		if ( targetID )
 			SendAssistanceRequests(obj);
 
@@ -2821,119 +2831,108 @@
 		/* If current bullets > 1 and no enemy seen recently then additional charge is lost */
 		if ( Get_Current_Bullets(obj) > 1 && targetID == 0 )
 			Set_Current_Bullets(obj,1);
-
-		// Trigger again when required
-		Commands->Start_Timer ( obj, this, 1.0, TIMER_PRISMTOWER_THINK );
 	}
 
 
-	// Otherwise pass the timer on to the base class
-	else
-		dp88_AI_Turret::Timer_Expired(obj, number);
+  // Pass the timer onto the base class to be handled
+  dp88_AI_ChargedTurret::Timer_Expired(obj, number);
 }
 
+// -------------------------------------------------------------------------------------------------
 
-
-
-// Override priority calculation with our own taking into account
-// the fact that the target might be a tower we are charging
 float dp88_AR_Prism_Tower::getPriority( GameObject *obj, GameObject *target )
 {
 	// If the target is the tower we are currently charging then return
 	// the priority of that charging sequence
-	if ( Commands->Get_ID(target) == targetID && isChargingTower )
+  if ( Commands->Get_ID(target) == targetID && isAssistingTower )
 		return targetPriority;
 
 	// Otherwise run the normal priority calculation
-	return dp88_AI_Turret::getPriority(obj, target);
+  return dp88_AI_ChargedTurret::getPriority(obj, target);
 }
 
+// -------------------------------------------------------------------------------------------------
 
-// Override the team check mechanism to return true when charging another
-// tower, even though the target is on the same team
 bool dp88_AR_Prism_Tower::checkTeam( GameObject *obj, GameObject *target )
 {
-	// If the target is the tower we are currently charging then return
-	// the priority of that charging sequence
-	if ( Commands->Get_ID(target) == targetID && isChargingTower )
+  // Return true for the tower we are charging, even though it is on the same team as us
+  if ( Commands->Get_ID(target) == targetID && isAssistingTower )
 		return true;
 
 	// Otherwise run the normal check team function
-	return dp88_AI_Turret::checkTeam(obj, target);
+  return dp88_AI_ChargedTurret::checkTeam(obj, target);
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::attackTarget ( GameObject* obj, GameObject* target, bool primary )	
 {
 	// Call base classes attack routine
-	dp88_AI_Turret::attackTarget(obj, target, primary);
+  dp88_AI_ChargedTurret::attackTarget(obj, target, primary);
 
 	// Send notifications for assistance
 	SendAssistanceRequests(obj);
 }
 
+// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Prism_Tower::attackLocation ( GameObject* obj, Vector3 location, bool primary )
 {
 	// Call base classes attack routine
-	dp88_AI_Turret::attackLocation(obj, location, primary);
+  dp88_AI_ChargedTurret::attackLocation(obj, location, primary);
 
 	// Send notifications for assistance
 	SendAssistanceRequests(obj);
 }
 
+// -------------------------------------------------------------------------------------------------
+
 
 void dp88_AR_Prism_Tower::stopAttacking ( GameObject* obj )
 {
-	// Was the target a tower we were charging? If so this means they
-	// must have timed out on the last seen and are therefore probably
-	// dead...
-	if ( isChargingTower )
-		StopCharging(obj);
+  // Was the target a tower we were charging? If so this means they must have timed out on the last
+  // seen and are therefore probably dead...
+  if ( isAssistingTower )
+    StopAssisting(obj);
 
-	// Otherwise we were attacking a normal target, send out end assistance
-	// notifications to all adjacent towers and call base class
+  // Otherwise we were attacking a normal target, send out end assistance notifications to all
+  // adjacent towers and call base class
 	else
 	{
 		SendEndAssistanceNotifications(obj);
-		dp88_AI_Turret::stopAttacking(obj);
+    dp88_AI_ChargedTurret::stopAttacking(obj);
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
 /* Start charging the specified tower */
-void dp88_AR_Prism_Tower::StartCharging(GameObject* obj, GameObject* tower, float priority)
+void dp88_AR_Prism_Tower::StartAssisting(GameObject* obj, GameObject* tower, float priority)
 {
 	// Set our new target ID and priority
 	targetID = Commands->Get_ID(tower);
 	targetPriority = priority;
 	targetLastSeen = (int)time(NULL);
-	isChargingTower = true;
+  isAssistingTower = true;
 
 	// Work out attack position
 	Vector3 chargePos = Commands->Get_Bone_Position(tower,"turret");
 	chargePos.Z += 1;
 
-	// Start charging the tower
-	ActionParamsStruct params;
-	params.Set_Basic( this, 100, 2 );
-	params.Set_Attack( chargePos, (float)primary_maxRange, 0.0, true);
-	params.AttackCheckBlocked = false;
-	Commands->Action_Attack( obj, params );
-
-	// Send notifications for assistance
-	SendAssistanceRequests(obj);
+  // Start charging the tower - this will also trigger assistance notifications to be sent out
+  attackLocation ( obj, chargePos, true );
 }
 
+// -------------------------------------------------------------------------------------------------
 
 /* Stop charging the specified tower */
-void dp88_AR_Prism_Tower::StopCharging(GameObject* obj)
+void dp88_AR_Prism_Tower::StopAssisting(GameObject* obj)
 {
-	if ( isChargingTower )
+  if ( isAssistingTower )
 	{
 		targetID = NULL;
 		targetPriority = 0;
-		isChargingTower = false;
+    isAssistingTower = false;
 		Commands->Action_Reset(obj, 101.0f);
 	}
 	
@@ -2941,13 +2940,11 @@
 	SendEndAssistanceNotifications(obj);
 }
 
+// -------------------------------------------------------------------------------------------------
 
-// Function to send assistance requests to all adjacent towers,
-// except the one we are currently charging
 void dp88_AR_Prism_Tower::SendAssistanceRequests(GameObject* obj)
 {
-	// Send out assistance requests to all adjacent towers except the one
-	// we are charging, if any
+  // Send out assistance requests to all adjacent towers except the one we are charging, if any
 	for ( int i = 0; i < adjacentTowerCount; ++i )
 	{
 		if ( adjacentTowers[i] != targetID && Commands->Find_Object(adjacentTowers[i]) != obj)
@@ -2955,9 +2952,8 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
 
-// Function to send assistance requests to all adjacent towers,
-// except the one we are currently charging
 void dp88_AR_Prism_Tower::SendEndAssistanceNotifications(GameObject* obj)
 {
 	// Send out end assistance notifications to all adjacent towers
@@ -2970,6 +2966,8 @@
 	}
 }
 
+// -------------------------------------------------------------------------------------------------
+
 
 
 
@@ -3109,8 +3107,8 @@
 ScriptRegistrant<dp88_AR_CLEG_target> dp88_AR_CLEG_target_Registrant( "dp88_AR_CLEG_target", "resistance=20:int,clegEffectPreset=null:string" );
 
 // Ore Miners
-ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string");
-ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string");
+ScriptRegistrant<dp88_AR_Miner> dp88_AR_Miner_Registrant("dp88_AR_War_Miner","enableAI=1:int,loadLevels=10:int,orePerLoadLevel=100:int,timePerLoadLevel=2.0:float,unloadTime=8.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string,idleAnimation:string");
+ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant("dp88_AR_Chrono_Miner","enableAI=1:int,chronoshift_time=2.5:float,chronoshift_out_effect_preset:string,chronoshift_out_effect_time:float,chronoshift_in_effect_preset:string,chronoshift_in_effect_time:float,chronoshiftKeyhook=VDeploy:string,loadLevels=10:int,orePerLoadLevel=50:int,timePerLoadLevel=1.00:float,unloadTime=4.0:float,emergencyChronoshiftHealthThreshold=30.0:float,aiStartDelay=10:int,dockAnimation:string,dockSound:string,miningAnimation:String,miningSound:string,idleAnimation:string");
 ScriptRegistrant<dp88_AR_Chrono_Miner_Chronozone> dp88_AR_Chrono_Miner_Chronozone_Registrant("dp88_AR_Chrono_Miner_Chronozone","");
 ScriptRegistrant<dp88_AR_Ore_Field_Zone> dp88_AR_Ore_Field_Zone_Registrant("dp88_AR_Ore_Field_Zone","oreValue=1:int");
 ScriptRegistrant<dp88_AR_Ore_Deposit_Zone> dp88_AR_Ore_Deposit_Zone_Registrant("dp88_AR_Ore_Deposit_Zone","teamID=0:int");
@@ -3138,7 +3136,7 @@
 ScriptRegistrant<dp88_AR_paradrop> dp88_AR_paradrop_Registrant("dp88_AR_paradrop","infantry_preset:string");
 
 // Prism Tower script
-ScriptRegistrant<dp88_AR_Prism_Tower> dp88_AR_Prism_Tower_Registrant("dp88_AR_Prism_Tower","Priority_Infantry=1.0:float,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Priority_Heavy_Vehicle=7.0:float,Priority_VTOL=0.0:float,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.25:float,Requires_Power=1:int,Debug=0:int");
+ScriptRegistrant<dp88_AR_Prism_Tower> dp88_AR_Prism_Tower_Registrant("dp88_AR_Prism_Tower","Priority_Infantry=1.0:float,Splash_Infantry=0:int,Priority_Light_Vehicle=5.0:float,Priority_Heavy_Vehicle=7.0:float,Priority_VTOL=0.0:float,Min_Attack_Range=0:int,Max_Attack_Range=150:int,Animation_Model:string,Animation_Model_Bone:string,Animation:string,Animation_Idle_Start_Frame:int,Animation_Idle_End_Frame:int,Animation_Unpowered_Start_Frame:int,Animation_Unpowered_End_Frame:int,Animation_Charge_Start_Frame:int,Animation_Charge_End_Frame:int,Charge_Sound:string,Modifier_Distance=0.25:float,Modifier_Target_Damage=0.1:float,Modifier_Target_Value=0.25:float,Requires_Power=1:int,Debug=0:int");
 
 // Health link script
 ScriptRegistrant<dp88_linkHealth> dp88_linkHealth_Registrant("dp88_linkHealth","parentObjectId=0:int");
diff -uwrN sourceold/scripts/dp88_ar.h source/scripts/dp88_ar.h
--- sourceold/scripts/dp88_ar.h	2012-05-23 10:33:45.797851500 +0800
+++ source/scripts/dp88_ar.h	2012-08-14 23:00:33.552734300 +0800
@@ -232,6 +232,8 @@
 *   An optional animation to be played in a loop whilst mining in an ore field
 * \param miningSound
 *   An optional sound effect to be played each time the ore load level increases
+* \param idleAnimation
+*   An optional animation to be played in a loop when the miner is not mining or docked
 *
 * \note
 *   Because this script is designed to act as a base class for both types of AR miner it is not
@@ -532,11 +534,80 @@
 
 
 
-/*------------------------
-Prism Tower Script
---------------------------*/
+// -------------------------------------------------------------------------------------------------
 
-class dp88_AR_Prism_Tower : public dp88_AI_Turret
+/*!
+* \brief AR Prism Tower script
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This script implements the prism tower logic for Apocalypse Rising on top of the generic charged
+* turret implementation provided by dp88_AI_ChargedTurret.
+*
+* \param Priority_Infantry
+*   Base targetting priority for infantry targets, or 0 to ignore infantry
+* \param Splash_Infantry
+*   Determines if we should try to damage infantry with splash instead of hitting them directly.
+*   This is useful for slow / inaccurate weapons which do splash damage: 1 to enable, 0 to disable
+* \param Priority_Light_Vehicle
+*   Base targetting priority for light vehicle targets, or 0 to ignore light vehicles
+* \param Priority_Heavy_Vehicle
+*   Base targetting priority for heavy vehicle targets, or 0 to ignore heavy vehicles
+* \param Priority_VTOL
+*   Base targetting priority for flying targets, or 0 to ignore flying targets
+* \param Min_Attack_Range
+*   Minimum distance at which the turret can engage enemies when using primary fire
+* \param Max_Attack_Range
+*   Maximum distance at which the turret can engage enemies when using primary fire
+* \param Animation_Model
+*   Optional name of a W3D model file to spawn and attach to the turret upon which the charge
+*   animations defined in this script will be applied. This allows the turret itself to be running
+*   a different set of animations, such as damage states via dp88_damageAnimation
+* \param Animation_Model_Bone
+*   If you specify an Animation_Model above then you must also specify the a bone on the parent
+*   to which that model should be attached. This allows the animation model to be moved by the
+*   animation set executing on the turret.
+* \param Animation
+*   Name of the animation which contains the frames for the various charge states
+* \param Animation_Idle_Start_Frame
+*   First frame number for the idle animation, which will loop continually whilst the turret is
+*   powered and not currently attacking a target
+* \param Animation_Idle_End_Frame
+*   Final frame number for the idle animation
+* \param Animation_Unpowered_Start_Frame
+*   First frame number for the unpowered animation, which will loop continually whilst the turret
+*   is in the unpowered state. This is not used if Requires_Power is disabled (see below).
+* \param Animation_Unpowered_End_Frame
+*   Final frame number for the unpowered animation
+* \param Animation_Charge_Start_Frame
+*   First frame number for the charging animation, which will be played once each time the turret
+*   reloads its weapon. Once this animation completes the turret will fire again, therefore the
+*   length of this animation must be greater than the weapon reload time.
+* \param Animation_Charge_End_Frame
+*   Final frame number for the charging animation
+* \param Charge_Sound
+*   Optional sound effect to be played each time the turret starts charging up
+* \param Modifier_Distance
+*   Priority modification to apply based on distance to target. Higher values will favour targets
+*   which are closer to the turret, good for less accurate weapons
+* \param Modifier_Target_Damage
+*   Priority modification to apply based on damage a target has already sustained. Higher values
+*   will favour targets which have already been damaged in combat, picking them off first.
+* \param Modifier_Target_Value
+*   Priority modification to apply based on the value of the target. Higher values will favour
+*   targets with a higher purchase cost, good for hard hitting weapons.
+* \param Requires_Power
+*   Specify whether this turret requires base power to operate: 1 to require power, 0 to ignore
+* \param Debug
+*   Specify whether to produce a debug logfile about the turrets targetting decisions, this is
+*   useful for fine tuning your base priorities and modifiers: 1 to enable, 0 to disable.
+*
+* \todo
+*   Decide on a mechanism to ensure each firing sequence fires one bullet per assisting tower,
+*   regardless of chain length. Can possibly overload dp88_AI_ChargedTurret::StartDischarging() to
+*   introduce a 0.1 second delay for each level of assisting tower depth to ensure the charging
+*   shot arrives before it fires its own attacking (or chain charging) shot.
+*/
+class dp88_AR_Prism_Tower : public dp88_AI_ChargedTurret
 {
 	/* -----
 	Static variables
@@ -561,7 +632,7 @@
 	----- */
 
 	// Is our current target a tower we are charging?
-	bool isChargingTower;
+  bool isAssistingTower;
 
 	// Towers adjacent to us in the tower map
 	int adjacentTowerCount;
@@ -587,8 +658,10 @@
 	// the fact that the target might be a tower we are charging
 	virtual float getPriority( GameObject *obj, GameObject *target );
 
-	// Override the team check mechanism to return true when charging another
-	// tower, even though the target is on the same team
+  /*!
+  * Overrides the team check mechanism to return true if the specified target is the tower we are
+  * currently charging, otherwise the base class target validation logic will cancel the 'attack'
+  */
 	virtual bool checkTeam( GameObject *obj, GameObject *target );
 
 	// Customised attack functionality
@@ -597,12 +670,18 @@
 	virtual void stopAttacking ( GameObject* obj );
 
 	/* Functions to start and stop charging of another tower */
-	void StartCharging(GameObject* obj, GameObject* tower, float priority);
-	void StopCharging(GameObject* obj);
+  void StartAssisting(GameObject* obj, GameObject* tower, float priority);
+  void StopAssisting(GameObject* obj);
 
-	// Function to send assistance requests to all adjacent towers,
-	// except the one we are currently charging
+  /*!
+  * Send assistance requests to all neighbouring prism towers, except the one we are currently
+  * assisting, if any
+  */
 	void SendAssistanceRequests(GameObject* obj);
+
+  /*!
+  * Send end assistance notifications to all neighnouring prism towers
+  */
 	void SendEndAssistanceNotifications(GameObject* obj);
 };
 
diff -uwrN sourceold/scripts/dp88_customAI.cpp source/scripts/dp88_customAI.cpp
--- sourceold/scripts/dp88_customAI.cpp	2012-05-23 10:21:56.112304600 +0800
+++ source/scripts/dp88_customAI.cpp	2012-08-16 09:51:47.679687500 +0800
@@ -213,6 +213,8 @@
 {
 	if ( vobj == NULL )
 		return false;
+	if ( vobj->Get_Definition().Get_Seat_Count() == 0)
+		return false;
 	return (vobj->Get_Occupant_Count() == 0);
 }
 
@@ -245,7 +247,7 @@
 	secondary_prefRange = Get_Int_Parameter ( "Preferred_Attack_Range_Secondary" );
 
 	// Start timer which runs for the lifetime of this object
-	Commands->Start_Timer ( obj, this, 1.0, TIMER_CHECK_TARGET );
+	Commands->Start_Timer ( obj, this, 1.0, TIMER_CUSTOMAI_THINK );
 }
 
 
@@ -324,7 +326,7 @@
 void dp88_tankAI_Offensive::Timer_Expired( GameObject *obj, int number )
 {
 	// Check target is still alive, still an enemy (eg: stolen vehicles) and in range
-	if ( number == TIMER_CHECK_TARGET )
+	if ( number == TIMER_CUSTOMAI_THINK )
 	{
 		if ( targetID != 0 )
 		{
@@ -400,7 +402,7 @@
 		}
 
 		// Timer always runs
-		Commands->Start_Timer ( obj, this, 1.0, TIMER_CHECK_TARGET );
+		Commands->Start_Timer ( obj, this, 1.0, TIMER_CUSTOMAI_THINK );
 	}
 }
 
@@ -425,7 +427,7 @@
 	dp88_customAI::Init( obj );
 
 	// Start timer which runs for the lifetime of this object
-	Commands->Start_Timer ( obj, this, 1.0, TIMER_CHECK_TARGET );
+	Commands->Start_Timer ( obj, this, 1.0, TIMER_CUSTOMAI_THINK );
 }
 
 void dp88_AI_Turret::loadSettings(  GameObject *obj, bool loadSecondaryFireSettings, bool loadBuildingTargetSettings )
@@ -502,7 +504,7 @@
 void dp88_AI_Turret::Timer_Expired( GameObject *obj, int number )
 {
 	// Check target is still alive, still an enemy (eg: stolen vehicles) and in range
-	if ( number == TIMER_CHECK_TARGET )
+	if ( number == TIMER_CUSTOMAI_THINK )
 	{
 		if ( targetID != 0 )
 		{
@@ -528,7 +530,7 @@
 		}
 
 		// Timer always runs
-		Commands->Start_Timer ( obj, this, 1.0, TIMER_CHECK_TARGET );
+		Commands->Start_Timer ( obj, this, 1.0, TIMER_CUSTOMAI_THINK );
 	}
 }
 
@@ -680,7 +682,7 @@
 void dp88_AI_PopupTurret::Timer_Expired ( GameObject* pSelf, int number )
 {
   // Piggy-back the undeploy timer logic on the existing target check timer since its always running
-  if ( number == TIMER_CHECK_TARGET && m_deploymentState == STATE_DEPLOYED )
+  if ( number == TIMER_CUSTOMAI_THINK && m_deploymentState == STATE_DEPLOYED )
   {
     // If we have no target and have reached the undeploy timeout then trigger undeployment
     if ( targetID == 0 && time(NULL) > m_undeployTime )
@@ -859,10 +861,9 @@
 
 void dp88_AI_ChargedTurret::Timer_Expired ( GameObject* pSelf, int number )
 {
-  // Piggy-back the base power state checks on the existing target check timer since its always
-  // running anyway. If the base power state changes we need to update the idle animation (and
-  // abort any charge up in progress)
-  if ( number == TIMER_CHECK_TARGET && m_bPowerState != checkPowerState(pSelf) )
+  // Use the existing custom AI think timer to check for a base power state changes and, if it has
+  // changed, update the idle animation (and abort any charge up in progress)
+  if ( number == TIMER_CUSTOMAI_THINK && m_bPowerState != checkPowerState(pSelf) )
   {
     m_bPowerState = !m_bPowerState;
 
@@ -885,7 +886,7 @@
 
 
   // We might as well piggy back the discharged checks on the same timer too whilst we are at it...
-  if ( number == TIMER_CHECK_TARGET && m_bIsDischarging )
+  if ( number == TIMER_CUSTOMAI_THINK && m_bIsDischarging )
   {
     // Have we unloaded our entire clip? If so then we can start charging for the next attack
     if ( Get_Current_Bullets(pSelf) == 0 )
@@ -917,27 +918,7 @@
 {
   if (!_stricmp(animation_name,Get_Parameter("Animation"))) //make sure we are running the right animation
   {
-    // Were we charging up? If so we are now fully charged and can start shooting stuff, if we still
-    // have a valid target...
-    if ( m_bIsCharging )
-    {
-      m_bIsCharging = false;
-      m_bIsDischarging = true;
-  
-      // Got an enemy? Also double check power state whilst we are here, just to be sure
-      if ( targetID != NULL && checkPowerState(pSelf) )
-      {
-        if ( GameObject* pTarget = Commands->Find_Object(targetID) )
-        {
-  
-          // Call into the base class and let it do it's thing
-          if ( splashInfantry && pTarget->As_SoldierGameObj() )
-            dp88_AI_Turret::attackLocation(pSelf, Commands->Get_Position(pTarget), primary_target);
-          else
-            dp88_AI_Turret::attackTarget(pSelf, pTarget, primary_target);
-        }
-      }
-    }
+    StartDischarging(pSelf);
   }
 
   dp88_AI_Turret::Animation_Complete(pSelf, animation_name);
@@ -1004,6 +985,37 @@
   }
 }
 
+// -------------------------------------------------------------------------------------------------
+
+void dp88_AI_ChargedTurret::StartDischarging ( GameObject* pSelf )
+{
+  // Were we charging up? If so we are now fully charged and can start shooting stuff, if we still
+  // have a valid target...
+  if ( m_bIsCharging )
+  {
+    m_bIsCharging = false;
+  
+    // Got an enemy? Also double check power state whilst we are here, just to be sure
+    if ( targetID != NULL && checkPowerState(pSelf) )
+    {
+      if ( GameObject* pTarget = Commands->Find_Object(targetID) )
+      {
+        m_bIsDischarging = true;
+
+        // Call into the base class and let it do it's thing
+        if ( splashInfantry && pTarget->As_SoldierGameObj() )
+          dp88_AI_Turret::attackLocation(pSelf, Commands->Get_Position(pTarget), primary_target);
+        else
+          dp88_AI_Turret::attackTarget(pSelf, pTarget, primary_target);
+      }
+    }
+
+    // If we didn't find anything to shoot at then apply the idle animation again
+    if ( !m_bIsDischarging )
+      ApplyIdleAnimation(pSelf);
+  }
+}
+
 // -------------------------------------------------------------------------------------------------
 
 GameObject* dp88_AI_ChargedTurret::GetAnimationObject ( GameObject* pSelf )
diff -uwrN sourceold/scripts/dp88_customAI.h source/scripts/dp88_customAI.h
--- sourceold/scripts/dp88_customAI.h	2012-05-13 21:10:00.739101500 +0800
+++ source/scripts/dp88_customAI.h	2012-07-28 09:11:05.283203100 +0800
@@ -13,8 +13,6 @@
 
 #include "LoopedAnimationController.h"
 
-#define TIMER_CHECK_TARGET 100778801
-
 
 /*------------------------
 Base class for custom AI's
@@ -532,6 +530,9 @@
   /*! This function is called to initiate the charge up process, if it is not already in progress */
   virtual void StartCharging ( GameObject* pSelf );
 
+  /*! This function is called when the turret is fully charged and is ready to fire at something */
+  virtual void StartDischarging ( GameObject* pSelf );
+
 
   /*! Internal utility function to get a pointer to the object upon which the charge animation will
   * be applied - this will either be the turret itself or the seperate charge animation object if
diff -uwrN sourceold/scripts/dp88_custom_timer_defines.h source/scripts/dp88_custom_timer_defines.h
--- sourceold/scripts/dp88_custom_timer_defines.h	2012-05-07 07:09:13.429789000 +0800
+++ source/scripts/dp88_custom_timer_defines.h	2012-07-28 09:11:07.176757800 +0800
@@ -134,7 +134,7 @@
 #define TIMER_BUILDINGSCRIPTS_TRICKLEMONEY			2244030501		// Runs on a trickle money effect to grant money once per second
 
 // Timers for prism towers and tesla coils
-#define TIMER_PRISMTOWER_THINK						2244040001
+#define TIMER_CUSTOMAI_THINK                          2244040001  // Timer that fires every 1 second in my custom AI scripts to update target state etc
 #define TIMER_TESLACOIL_DECREMENT_CHARGE			2244040002
 
 // Timers for dp88_chronoTank
diff -uwrN sourceold/scripts/engine_obj.cpp source/scripts/engine_obj.cpp
--- sourceold/scripts/engine_obj.cpp	2012-05-23 11:24:04.913085900 +0800
+++ source/scripts/engine_obj.cpp	2012-07-28 09:11:06.291015600 +0800
@@ -556,6 +556,24 @@
 	return ObjList;
 }
 
+GameObject SCRIPTS_API *Find_Closest_Building(const Vector3& position)
+{
+	GameObject* bestBuilding = 0;
+    float bestDistance = FLT_MAX;
+	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
+	while (x)
+	{
+		Vector3 offset = Commands->Get_Position(x->Data()) - position;
+		float distance = offset.Length2();
+		if (distance < bestDistance)
+		{
+			bestBuilding = x->Data();
+			bestDistance = distance;
+		}
+	}
+    return bestBuilding;
+}
+
 GameObject SCRIPTS_API *Find_Nearest_Preset(Vector3 position, const char *preset)
 {
 	GameObject *object = 0;
